=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2007-10-25 01:43:26 +0000
+++ bzrlib/bzrdir.py	2007-10-25 01:55:55 +0000
@@ -2293,10 +2293,11 @@
 
 class BzrDirFormatInfo(object):
 
-    def __init__(self, native, deprecated, hidden):
+    def __init__(self, native, deprecated, hidden, experimental):
         self.deprecated = deprecated
         self.native = native
         self.hidden = hidden
+        self.experimental = experimental
 
 
 class BzrDirFormatRegistry(registry.Registry):
@@ -2310,7 +2311,8 @@
              repository_format, help, native=True, deprecated=False,
              branch_format=None,
              tree_format=None,
-             hidden=False):
+             hidden=False,
+             experimental=False):
         """Register a metadir subformat.
 
         These all use a BzrDirMetaFormat1 bzrdir, but can be parameterized
@@ -2348,10 +2350,11 @@
             if repository_format is not None:
                 bd.repository_format = _load(repository_format)
             return bd
-        self.register(key, helper, help, native, deprecated, hidden)
+        self.register(key, helper, help, native, deprecated, hidden,
+            experimental)
 
     def register(self, key, factory, help, native=True, deprecated=False,
-                 hidden=False):
+                 hidden=False, experimental=False):
         """Register a BzrDirFormat factory.
         
         The factory must be a callable that takes one parameter: the key.
@@ -2361,12 +2364,12 @@
         supplied directly.
         """
         registry.Registry.register(self, key, factory, help, 
-            BzrDirFormatInfo(native, deprecated, hidden))
+            BzrDirFormatInfo(native, deprecated, hidden, experimental))
 
     def register_lazy(self, key, module_name, member_name, help, native=True,
-                      deprecated=False, hidden=False):
+                      deprecated=False, hidden=False, experimental=False):
         registry.Registry.register_lazy(self, key, module_name, member_name, 
-            help, BzrDirFormatInfo(native, deprecated, hidden))
+            help, BzrDirFormatInfo(native, deprecated, hidden, experimental))
 
     def set_default(self, key):
         """Set the 'default' key to be a clone of the supplied key.
@@ -2419,14 +2422,22 @@
             output += wrapped(default_realkey, '(default) %s' % default_help,
                               self.get_info('default'))
         deprecated_pairs = []
+        experimental_pairs = []
         for key, help in help_pairs:
             info = self.get_info(key)
             if info.hidden:
                 continue
             elif info.deprecated:
                 deprecated_pairs.append((key, help))
+            elif info.experimental:
+                experimental_pairs.append((key, help))
             else:
                 output += wrapped(key, help, info)
+        if len(experimental_pairs) > 0:
+            output += "Experimental formats are shown below.\n\n"
+            for key, help in experimental_pairs:
+                info = self.get_info(key)
+                output += wrapped(key, help, info)
         if len(deprecated_pairs) > 0:
             output += "Deprecated formats are shown below.\n\n"
             for key, help in deprecated_pairs:
@@ -2486,7 +2497,7 @@
         'not be upgradable to release formats of bzr.',
     branch_format='bzrlib.branch.BzrBranchFormat6',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
-    hidden=True,
+    experimental=True,
     )
 format_registry.register_metadir('knitpack-subtree',
     'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack3',

